FLTK 1.3.3: Fl_Single_Window Class Reference

FLTK 1.3.3

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | List of all members
Fl_Single_Window Class Reference

This is the same as Fl_Window. More...

`#include <Fl_Single_Window.H>`

Inheritance diagram for Fl_Single_Window:

## Public Member Functions
| Fl_Single_Window (int W, int H, const char *l=0)
| Creates a new Fl_Single_Window widget using the given size, and label (title) string.
| Fl_Single_Window (int X, int Y, int W, int H, const char *l=0)
| Creates a new Fl_Single_Window widget using the given position, size, and label (title) string.
void | flush ()
| Forces the window to be drawn, this window is also made current and calls draw(). More...
int | make_current ()
void | show ()
| Puts the window on the screen. More...
void | show (int a, char **b)
Public Member Functions inherited from Fl_Window
virtual Fl_Window * | as_window ()
| Returns an Fl_Window pointer if this widget is an Fl_Window. More...
void | border (int b)
| Sets whether or not the window manager border is around the window. More...
unsigned int | border () const
| See void Fl_Window::border(int)
void | clear_border ()
| Fast inline function to turn the window manager border off. More...
void | clear_modal_states ()
| Clears the "modal" flags and converts a "modal" or "non-modal" window back into a "normal" window. More...
void | copy_label (const char *a)
| Sets the window titlebar label to a copy of a character string.
void | cursor (Fl_Cursor)
| Changes the cursor for this window. More...
void | cursor (const Fl_RGB_Image *, int, int)
| Changes the cursor for this window. More...
void | cursor (Fl_Cursor c, Fl_Color, Fl_Color=FL_WHITE)
| For back compatibility only. More...
int | decorated_h ()
| Returns the window height including any window title bar and any frame added by the window manager. More...
int | decorated_w ()
| Returns the window width including any frame added by the window manager. More...
void | default_cursor (Fl_Cursor)
| Sets the default window cursor. More...
void | default_cursor (Fl_Cursor c, Fl_Color, Fl_Color=FL_WHITE)
| For back compatibility only. More...
| Fl_Window (int w, int h, const char *title=0)
| Creates a window from the given size and title. More...
| Fl_Window (int x, int y, int w, int h, const char *title=0)
| Creates a window from the given position, size and title. More...
void | free_position ()
| Undoes the effect of a previous resize() or show() so that the next time show() is called the window manager is free to position the window. More...
void | fullscreen ()
| Makes the window completely fill one or more screens, without any window manager border visible. More...
unsigned int | fullscreen_active () const
| Returns non zero if FULLSCREEN flag is set, 0 otherwise.
void | fullscreen_off ()
| Turns off any side effects of fullscreen()
void | fullscreen_off (int X, int Y, int W, int H)
| Turns off any side effects of fullscreen() and does resize(x,y,w,h).
void | fullscreen_screens (int top, int bottom, int left, int right)
| Sets which screens should be used when this window is in fullscreen mode. More...
virtual int | handle (int)
| Handles the specified event. More...
virtual void | hide ()
| Removes the window from the screen. More...
void | hotspot (int x, int y, int offscreen=0)
| Positions the window so that the mouse is pointing at the given position, or at the center of the given widget, which may be the window itself. More...
void | hotspot (const Fl_Widget *, int offscreen=0)
| See void Fl_Window::hotspot(int x, int y, int offscreen = 0)
void | hotspot (const Fl_Widget &p, int offscreen=0)
| See void Fl_Window::hotspot(int x, int y, int offscreen = 0)
void | icon (const Fl_RGB_Image *)
| Sets a single window icon. More...
const void * | icon () const
| Gets the current icon window target dependent data. More...
void | icon (const void *ic)
| Sets the current icon window target dependent data. More...
void | iconize ()
| Iconifies the window. More...
const char * | iconlabel () const
| See void Fl_Window::iconlabel(const char*)
void | iconlabel (const char *)
| Sets the icon label. More...
void | icons (const Fl_RGB_Image *[], int)
| Sets the window icons. More...
const char * | label () const
| See void Fl_Window::label(const char*)
void | label (const char *)
| Sets the window title bar label. More...
void | label (const char *label, const char *iconlabel)
| Sets the icon label. More...
void | make_current ()
| Sets things up so that the drawing functions in <FL/fl_draw.H> will go into this window. More...
unsigned int | menu_window () const
| Returns true if this window is a menu window. More...
unsigned int | modal () const
| Returns true if this window is modal. More...
unsigned int | non_modal () const
| Returns true if this window is modal or non-modal. More...
unsigned int | override () const
| Returns non zero if FL_OVERRIDE flag is set, 0 otherwise. More...
virtual void | resize (int X, int Y, int W, int H)
| Changes the size and position of the window. More...
void | set_menu_window ()
| Marks the window as a menu window. More...
void | set_modal ()
| A "modal" window, when shown(), will prevent any events from being delivered to other windows in the same program, and will also remain on top of the other windows (if the X window manager supports the "transient for" property). More...
void | set_non_modal ()
| A "non-modal" window (terminology borrowed from Microsoft Windows) acts like a modal() one in that it remains on top, but it has no effect on event delivery. More...
void | set_override ()
| Activates the flags NOBORDER|FL_OVERRIDE.
void | set_tooltip_window ()
| Marks the window as a tooltip window. More...
void | shape (const Fl_Image *img)
| Assigns a non-rectangular shape to the window. More...
void | shape (const Fl_Image &b)
| Set the window's shape with an Fl_Image. More...
void | show (int argc, char **argv)
| Puts the window on the screen and parses command-line arguments. More...
int | shown ()
| Returns non-zero if show() has been called (but not hide() ). More...
void | size_range (int minw, int minh, int maxw=0, int maxh=0, int dw=0, int dh=0, int aspect=0)
| Sets the allowable range the user can resize this window to. More...
unsigned int | tooltip_window () const
| Returns true if this window is a tooltip window. More...
void | wait_for_expose ()
| Waits for the window to be fully displayed after calling show(). More...
int | x_root () const
| Gets the x position of the window on the screen.
const char * | xclass () const
| Returns the xclass for this window, or a default. More...
void | xclass (const char *c)
| Sets the xclass for this window. More...
int | y_root () const
| Gets the y position of the window on the screen.
virtual | ~Fl_Window ()
| The destructor also deletes all the children. More...
Public Member Functions inherited from Fl_Group
Fl_Widget *& | _ddfdesign_kludge ()
| This is for forms compatibility only.
void | add (Fl_Widget &)
| The widget is removed from its current group (if any) and then added to the end of this group.
void | add (Fl_Widget *o)
| See void Fl_Group::add(Fl_Widget &w)
void | add_resizable (Fl_Widget &o)
| Adds a widget to the group and makes it the resizable widget.
Fl_Widget *const * | array () const
| Returns a pointer to the array of children. More...
virtual Fl_Group * | as_group ()
| Returns an Fl_Group pointer if this widget is an Fl_Group. More...
void | begin ()
| Sets the current group so you can build the widget tree by just constructing the widgets. More...
Fl_Widget * | child (int n) const
| Returns array()[n]. More...
int | children () const
| Returns how many child widgets the group has.
void | clear ()
| Deletes all child widgets from memory recursively. More...
void | clip_children (int c)
| Controls whether the group widget clips the drawing of child widgets to its bounding box. More...
unsigned int | clip_children ()
| Returns the current clipping mode. More...
void | end ()
| Exactly the same as current(this->parent()). More...
int | find (const Fl_Widget *) const
| Searches the child array for the widget and returns the index. More...
int | find (const Fl_Widget &o) const
| See int Fl_Group::find(const Fl_Widget *w) const.
| Fl_Group (int, int, int, int, const char *=0)
| Creates a new Fl_Group widget using the given position, size, and label string. More...
void | focus (Fl_Widget *W)
void | forms_end ()
| This is for forms compatibility only.
void | init_sizes ()
| Resets the internal array of widget sizes and positions. More...
void | insert (Fl_Widget &, int i)
| The widget is removed from its current group (if any) and then inserted into this group. More...
void | insert (Fl_Widget &o, Fl_Widget *before)
| This does insert(w, find(before)). More...
void | remove (int index)
| Removes the widget at `index` from the group but does not delete it. More...
void | remove (Fl_Widget &)
| Removes a widget from the group but does not delete it. More...
void | remove (Fl_Widget *o)
| Removes the widget `o` from the group. More...
void | resizable (Fl_Widget &o)
| See void Fl_Group::resizable(Fl_Widget *box)
void | resizable (Fl_Widget *o)
| The resizable widget defines the resizing box for the group. More...
Fl_Widget * | resizable () const
| See void Fl_Group::resizable(Fl_Widget *box)
virtual | ~Fl_Group ()
| The destructor also deletes all the children. More...
Public Member Functions inherited from Fl_Widget
void | _clear_fullscreen ()
void | _set_fullscreen ()
void | activate ()
| Activates the widget. More...
unsigned int | active () const
| Returns whether the widget is active. More...
int | active_r () const
| Returns whether the widget and all of its parents are active. More...
Fl_Align | align () const
| Gets the label alignment. More...
void | align (Fl_Align alignment)
| Sets the label alignment. More...
long | argument () const
| Gets the current user data (long) argument that is passed to the callback function.
void | argument (long v)
| Sets the current user data (long) argument that is passed to the callback function. More...
virtual class Fl_Gl_Window * | as_gl_window ()
| Returns an Fl_Gl_Window pointer if this widget is an Fl_Gl_Window. More...
Fl_Boxtype | box () const
| Gets the box type of the widget. More...
void | box (Fl_Boxtype new_box)
| Sets the box type for the widget. More...
Fl_Callback_p | callback () const
| Gets the current callback function for the widget. More...
void | callback (Fl_Callback *cb, void *p)
| Sets the current callback function for the widget. More...
void | callback (Fl_Callback *cb)
| Sets the current callback function for the widget. More...
void | callback (Fl_Callback0 *cb)
| Sets the current callback function for the widget. More...
void | callback (Fl_Callback1 *cb, long p=0)
| Sets the current callback function for the widget. More...
unsigned int | changed () const
| Checks if the widget value changed since the last callback. More...
void | clear_active ()
| Marks the widget as inactive without sending events or changing focus. More...
void | clear_changed ()
| Marks the value of the widget as unchanged. More...
void | clear_damage (uchar c=0)
| Clears or sets the damage flags. More...
void | clear_output ()
| Sets a widget to accept input. More...
void | clear_visible ()
| Hides the widget. More...
void | clear_visible_focus ()
| Disables keyboard focus navigation with this widget. More...
Fl_Color | color () const
| Gets the background color of the widget. More...
void | color (Fl_Color bg)
| Sets the background color of the widget. More...
void | color (Fl_Color bg, Fl_Color sel)
| Sets the background and selection color of the widget. More...
Fl_Color | color2 () const
| For back compatibility only. More...
void | color2 (unsigned a)
| For back compatibility only. More...
int | contains (const Fl_Widget *w) const
| Checks if w is a child of this widget. More...
void | copy_label (const char *new_label)
| Sets the current label. More...
void | copy_tooltip (const char *text)
| Sets the current tooltip text. More...
uchar | damage () const
| Returns non-zero if draw() needs to be called. More...
void | damage (uchar c)
| Sets the damage bits for the widget. More...
void | damage (uchar c, int x, int y, int w, int h)
| Sets the damage bits for an area inside the widget. More...
int | damage_resize (int, int, int, int)
| Internal use only. More...
void | deactivate ()
| Deactivates the widget. More...
Fl_Image * | deimage ()
| Gets the image that is used as part of the widget label. More...
const Fl_Image * | deimage () const
void | deimage (Fl_Image *img)
| Sets the image to use as part of the widget label. More...
void | deimage (Fl_Image &img)
| Sets the image to use as part of the widget label. More...
void | do_callback ()
| Calls the widget callback. More...
void | do_callback (Fl_Widget *o, long arg)
| Calls the widget callback. More...
void | do_callback (Fl_Widget *o, void *arg=0)
| Calls the widget callback. More...
void | draw_label (int, int, int, int, Fl_Align) const
| Draws the label in an arbitrary bounding box with an arbitrary alignment. More...
int | h () const
| Gets the widget height. More...
Fl_Image * | image ()
| Gets the image that is used as part of the widget label. More...
const Fl_Image * | image () const
void | image (Fl_Image *img)
| Sets the image to use as part of the widget label. More...
void | image (Fl_Image &img)
| Sets the image to use as part of the widget label. More...
int | inside (const Fl_Widget *wgt) const
| Checks if this widget is a child of `wgt`. More...
const char * | label () const
| Gets the current label text. More...
void | label (const char *text)
| Sets the current label pointer. More...
void | label (Fl_Labeltype a, const char *b)
| Shortcut to set the label text and type in one call. More...
Fl_Color | labelcolor () const
| Gets the label color. More...
void | labelcolor (Fl_Color c)
| Sets the label color. More...
Fl_Font | labelfont () const
| Gets the font to use. More...
void | labelfont (Fl_Font f)
| Sets the font to use. More...
Fl_Fontsize | labelsize () const
| Gets the font size in pixels. More...
void | labelsize (Fl_Fontsize pix)
| Sets the font size in pixels. More...
Fl_Labeltype | labeltype () const
| Gets the label type. More...
void | labeltype (Fl_Labeltype a)
| Sets the label type. More...
void | measure_label (int &ww, int &hh) const
| Sets width ww and height hh accordingly with the label size. More...
unsigned int | output () const
| Returns if a widget is used for output only. More...
Fl_Group * | parent () const
| Returns a pointer to the parent widget. More...
void | parent (Fl_Group *p)
| Internal use only - "for hacks only". More...
void | position (int X, int Y)
| Repositions the window or widget. More...
void | redraw ()
| Schedules the drawing of the widget. More...
void | redraw_label ()
| Schedules the drawing of the label. More...
Fl_Color | selection_color () const
| Gets the selection color. More...
void | selection_color (Fl_Color a)
| Sets the selection color. More...
void | set_active ()
| Marks the widget as active without sending events or changing focus. More...
void | set_changed ()
| Marks the value of the widget as changed. More...
void | set_normal_keyboard ()
| Marks a widget to use the normal keyboard model. More...
void | set_output ()
| Sets a widget to output only. More...
void | set_simple_keyboard ()
| Marks a widget to use the simple keyboard model. More...
void | set_visible ()
| Makes the widget visible. More...
void | set_visible_focus ()
| Enables keyboard focus navigation with this widget. More...
unsigned int | simple_keyboard () const
| Returns if the widget sees a simplified keyboard model or not. More...
void | size (int W, int H)
| Changes the size of the widget. More...
int | take_focus ()
| Gives the widget the keyboard focus. More...
unsigned int | takesevents () const
| Returns if the widget is able to take events. More...
int | test_shortcut ()
| Returns true if the widget's label contains the entered '&x' shortcut. More...
const char * | tooltip () const
| Gets the current tooltip text. More...
void | tooltip (const char *text)
| Sets the current tooltip text. More...
Fl_Window * | top_window () const
| Returns a pointer to the top-level window for the widget. More...
Fl_Window * | top_window_offset (int &xoff, int &yoff) const
| Finds the x/y offset of the current widget relative to the top-level window. More...
uchar | type () const
| Gets the widget type. More...
void | type (uchar t)
| Sets the widget type. More...
int | use_accents_menu ()
| Returns non zero if MAC_USE_ACCENTS_MENU flag is set, 0 otherwise.
void * | user_data () const
| Gets the user data for this widget. More...
void | user_data (void *v)
| Sets the user data for this widget. More...
unsigned int | visible () const
| Returns whether a widget is visible. More...
void | visible_focus (int v)
| Modifies keyboard focus navigation. More...
unsigned int | visible_focus ()
| Checks whether this widget has a visible focus. More...
int | visible_r () const
| Returns whether a widget and all its parents are visible. More...
int | w () const
| Gets the widget width. More...
Fl_When | when () const
| Returns the conditions under which the callback is called. More...
void | when (uchar i)
| Sets the flags used to decide when a callback is called. More...
Fl_Window * | window () const
| Returns a pointer to the nearest parent window up the widget hierarchy. More...
int | x () const
| Gets the widget position in its window. More...
int | y () const
| Gets the widget position in its window. More...
virtual | ~Fl_Widget ()
| Destroys the widget. More...

## Additional Inherited Members
Static Public Member Functions inherited from Fl_Window
static Fl_Window * | current ()
| Returns the last window that was made current. More...
static void | default_callback (Fl_Window *, void *v)
| Back compatibility: Sets the default callback v for win to call on close event.
static void | default_icon (const Fl_RGB_Image *)
| Sets a single default window icon. More...
static void | default_icons (const Fl_RGB_Image *[], int)
| Sets the default window icons. More...
static void | default_xclass (const char *)
| Sets the default window xclass. More...
static const char * | default_xclass ()
| Returns the default xclass. More...
Static Public Member Functions inherited from Fl_Group
static Fl_Group * | current ()
| Returns the currently active group. More...
static void | current (Fl_Group *g)
| Sets the current group. More...
Static Public Member Functions inherited from Fl_Widget
static void | default_callback (Fl_Widget *cb, void *d)
| Sets the default callback for all widgets. More...
static unsigned int | label_shortcut (const char *t)
| Returns the Unicode value of the '&x' shortcut in a given text. More...
static int | test_shortcut (const char *, const bool require_alt=false)
| Returns true if the given text `t` contains the entered '&x' shortcut. More...
Protected Types inherited from Fl_Widget
enum | { INACTIVE = 1<<0, INVISIBLE = 1<<1, OUTPUT = 1<<2, NOBORDER = 1<<3, FORCE_POSITION = 1<<4, NON_MODAL = 1<<5, SHORTCUT_LABEL = 1<<6, CHANGED = 1<<7, OVERRIDE = 1<<8, VISIBLE_FOCUS = 1<<9, COPIED_LABEL = 1<<10, CLIP_CHILDREN = 1<<11, MENU_WINDOW = 1<<12, TOOLTIP_WINDOW = 1<<13, MODAL = 1<<14, NO_OVERLAY = 1<<15, GROUP_RELATIVE = 1<<16, COPIED_TOOLTIP = 1<<17, FULLSCREEN = 1<<18, MAC_USE_ACCENTS_MENU = 1<<19, SIMPLE_KEYBOARD = 1<<20, USERFLAG3 = 1<<29, USERFLAG2 = 1<<30, USERFLAG1 = 1<<31 }
| flags possible values enumeration. More...
Protected Member Functions inherited from Fl_Window
virtual void | draw ()
| Draws the widget. More...
void | force_position (int force)
| Sets an internal flag that tells FLTK and the window manager to honor position requests. More...
int | force_position () const
| Returns the internal state of the window's FORCE_POSITION flag. More...
void | free_icons ()
| Deletes all icons previously attached to the window. More...
Protected Member Functions inherited from Fl_Group
void | draw_child (Fl_Widget &widget) const
| Forces a child to redraw. More...
void | draw_children ()
| Draws all children of the group. More...
void | draw_outside_label (const Fl_Widget &widget) const
| Parents normally call this to draw outside labels of child widgets. More...
int * | sizes ()
| Returns the internal array of widget sizes and positions. More...
void | update_child (Fl_Widget &widget) const
| Draws a child only if it needs it. More...
Protected Member Functions inherited from Fl_Widget
void | clear_flag (unsigned int c)
| Clears a flag in the flags mask.
void | draw_backdrop () const
| If FL_ALIGN_IMAGE_BACKDROP is set, the image or deimage will be drawn.
void | draw_box () const
| Draws the widget box according its box style.
void | draw_box (Fl_Boxtype t, Fl_Color c) const
| Draws a box of type t, of color c at the widget's position and size. More...
void | draw_box (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color c) const
| Draws a box of type t, of color c at the position X,Y and size W,H. More...
void | draw_focus ()
| draws a focus rectangle around the widget
void | draw_focus (Fl_Boxtype t, int x, int y, int w, int h) const
| Draws a focus box for the widget at the given position and size.
void | draw_label () const
| Draws the widget's label at the defined label position. More...
void | draw_label (int, int, int, int) const
| Draws the label in an arbitrary bounding box. More...
| Fl_Widget (int x, int y, int w, int h, const char *label=0L)
| Creates a widget at the given position and size. More...
unsigned int | flags () const
| Gets the widget flags mask.
void | h (int v)
| Internal use only. More...
void | set_flag (unsigned int c)
| Sets a flag in the flags mask.
void | w (int v)
| Internal use only. More...
void | x (int v)
| Internal use only. More...
void | y (int v)
| Internal use only. More...
Protected Attributes inherited from Fl_Window
shape_data_type * | shape_data_
| non-null means the window has a non-rectangular shape
Static Protected Attributes inherited from Fl_Window
static Fl_Window * | current_
| Stores the last window that was made current. More...

## Detailed Description

This is the same as Fl_Window.

However, it is possible that some implementations will provide double-buffered windows by default. This subcan be used to force single-buffering. This may be useful for modifying existing programs that use incremental update, or for some types of image data, such as a movie flipbook.

## Member Function Documentation

void Fl_Single_Window::flush | ( |  | ) |
| virtual

Forces the window to be drawn, this window is also made current and calls draw().

Reimplemented from Fl_Window.

void Fl_Single_Window::show | ( |  | ) |
| virtual

Puts the window on the screen.

Usually (on X) this has the side effect of opening the display.

If the window is already shown then it is restored and raised to the top. This is really convenient because your program can call show() at any time, even if the window is already up. It also means that show() serves the purpose of raise() in other toolkits.

Fl_Window::show(int argc, char **argv) is used for top-level windows and allows standard arguments to be parsed from the command-line.

See also
  Fl_Window::show(int argc, char **argv)

Reimplemented from Fl_Window.

The documentation for this class was generated from the following files:

- Fl_Single_Window.H
- Fl_Single_Window.cxx

- © 1998-2014 by Bill Spitzak and others.